
public class DiagonalMatrix implements Matrix {


	/**
	 * 
	 * @param diagonal
	 */
	public DiagonalMatrix(double[] diagonal) {
		this.diagonal = diagonal.clone();
	}
	
	public DiagonalMatrix(double[][] data) {
		diagonal = new double[data.length];
		for (int i= 0; i < data.length; i++) {
			diagonal[i] = data[i][i]; 
		}
	}
	
	@Override
	public double getElementAt(int row, int col) {
		return (row == col) ? diagonal[row] : 0;
	}

	@Override
	public int getHeight() {
		return diagonal.length;
	}

	@Override
	public int getWidth() {
		return diagonal.length;
	}

	@Override
	public Matrix multiply(Matrix other) {
		OrdinaryMatrix result = new OrdinaryMatrix(getHeight(), other.getWidth());
		for (int i = 0; i < diagonal.length; ++i) {
			for (int j = 0; j < other.getWidth(); ++j) {
				result.setElementAt(i, j, other.getElementAt(i, j) * diagonal[i]);
			}
		}
		return result;
	}
	
	public DiagonalMatrix multiply(DiagonalMatrix other) {
		double[] array = new double[diagonal.length];
		for (int i = 0; i < array.length; i++) {
			array[i] = this.diagonal[i] * other.diagonal[i];
		}
		return new DiagonalMatrix(array);
	}
	
	
	@Override
	public Matrix multiply(double scalar) {
		double[] array = diagonal.clone();
		
		for (int i = 0; i < array.length; i++) {
			array[i] *= scalar;
		}
		return new DiagonalMatrix(array);
	}
	
	@Override
	public void setElementAt(int row, int col, double newVal) {
		// TODO Auto-generated method stub
	}
	

	private double[] diagonal;
	
}
